<script lang="ts" setup>
import { ref } from 'vue'
import MsnApiV1 from '@/api/msnApi' // Importa MsnApiV1 en lugar de UserApiV1

const props = defineProps({
  subscriberId: Number,
  subscriberName: String,
})

// Definición de emits para TypeScript
const emit = defineEmits(['finished'])

const isDialogVisible = ref(false)
const deleteSubscriberName = ref('')
const isError = ref(false)
const errorMessage = ref('')
const isProcessing = ref<boolean>(false) // For waiting time and show a progres bar

const subscriberNameRules = [
  v => !!v || 'Subscriber name is required',
  v => v === props.subscriberName || `To delete the subscriber the name must be equal to ${props.subscriberName}`,
]

const handleOk = async () => {
  const valid = await validate()
  if (valid) {
    await deleteSubscriber()
    if (!isError.value)
      isDialogVisible.value = false
  }
}

const handleCancel = (): void => {
  isDialogVisible.value = false
  isError.value = false
}

const validate = async () => {
  if (deleteSubscriberName.value !== props.subscriberName) {
    isError.value = true
    errorMessage.value = `To delete the subscriber the name must be equal to ${props.subscriberName}`

    return false
  }

  return true
}

// Función para borrar el suscriptor
const deleteSubscriber = async () => {
  isProcessing.value = true

  const api = new MsnApiV1() // Usa MsnApiV1 en lugar de UserApiV1
  try {
    await api.deleteSubscriber(props.subscriberId) // Usa deleteSubscriber de MsnApiV1
    emit('finished') // Emitir evento 'finished' cuando el suscriptor es borrado exitosamente
    // Aquí puedes manejar cualquier lógica adicional tras borrar el suscriptor
  }
  catch (error) {
    console.error('Error deleting subscriber:', error)

    // Manejar errores aquí si es necesario
  }
  finally {
    isProcessing.value = false
  }
}
</script>

<template>
  <VDialog
    v-model="isDialogVisible"
    persistent
    max-width="600px"
  >
    <!-- Dialog Activator -->
    <template #activator="{ props }">
      <IconBtn v-bind="props">
        <VIcon
          color="error"
          icon="tabler-trash"
        />
      </IconBtn>
    </template>

    <!-- Dialog close btn -->
    <DialogCloseBtn @click="handleCancel" />

    <VCard>
      <VCardTitle class="text-h4">
        Are you absolutely sure?
      </VCardTitle>
      <VCardText>
        <VAlert
          border="start"
          border-color="error"
          color="error"
          variant="tonal"
          type="error"
        >
          Warning! You are about to delete this subscriber <strong>{{ subscriberName }}</strong>
          This process deletes the subscriber data and all related resources.
        </VAlert>
      </VCardText>
      <VCardText>
        <p>Enter the following to delete: <code> {{ subscriberName }} </code></p>
      </VCardText>
      <VCardText>
        <VRow>
          <VCol
            cols="12"
            sm="6"
            md="4"
          >
            <AppTextField
              v-model="deleteSubscriberName"
              label="Subscriber Name"
              :rules="subscriberNameRules"
              placeholder="Subscriber Name"
              autocomplete="off"
              outlined
              dense
            />
          </VCol>
        </VRow>
      </VCardText>

      <VAlert
        v-if="isError"
        type="error"
        dense
        closable
      >
        <VIcon left>
          mdi-information
        </VIcon>
        <span><strong>ERROR!</strong> {{ errorMessage }}.</span>
      </VAlert>

      <VCardActions>
        <VSpacer />
        <VBtn
          variant="tonal"
          color="secondary"
          @click="handleCancel"
        >
          Cancel, Keep Subscriber
        </VBtn>
        <VBtn
          color="red"
          :disabled="isProcessing"
          @click="handleOk"
        >
          Yes, Delete Subscriber
          <VProgressCircular
            v-if="isProcessing"
            indeterminate
            size="20"
          />
        </VBtn>
      </VCardActions>
    </VCard>
  </VDialog>
</template>

<style scoped>
code {
  white-space: pre; /* Mantiene los espacios y saltos de línea */
  padding: 2px 4px;
  color: #1f1e24;
  font-size: 120%;
  font-family: 'Fira Code', monospace; /* Fuente para código */
  background-color: #ececef;
  border-radius: 4px;
}
</style>
